// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _top_H_
#define _top_H_

#include "verilated.h"
#include "SpCoverage.h"
class top__Syms;

//----------

VL_MODULE(top) {
  public:
    // CELLS
    // Public to allow access to /*verilator_public*/ items;
    // otherwise the application code can consider these internals.
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clock,0,0);
    VL_IN8(reset,0,0);
    VL_IN8(x_in,5,0);
    VL_IN8(stbi,0,0);
    VL_OUT8(x_out,5,0);
    //char	__VpadToAlign5[3];
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    VL_SIG8(v__DOT__r_in,5,0);
    VL_SIG8(v__DOT__stato,3,0);
    VL_SIG8(v__DOT__cont,5,0);
    //char	__VpadToAlign15[1];
    VL_SIG(v__DOT__cont1,31,0);
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    VL_SIG8(__Vclklast__TOP__clock,0,0);
    //char	__VpadToAlign25[3];
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    top__Syms*	__VlSymsp;		// Symbol table
  private:
    // Coverage
    void __vlCoverInsert(uint32_t* countp, bool enable, const char* filenamep, int lineno, int column,
	const char* hierp, const char* pagep, const char* commentp);
    
    // PARAMETERS
    // Parameters marked /*verilator public*/ for use by application code
  public:
    
    // CONSTRUCTORS
  private:
    top& operator= (const top&);	///< Copying not allowed
    top(const top&);	///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible WRT DPI scope names.
    top(const char* name="TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~top();
    
    // USER METHODS
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(top__Syms* __restrict vlSymsp);
  public:
    void __Vconfigure(top__Syms* symsp, bool first);
  private:
    static IData	_change_request(top__Syms* __restrict vlSymsp);
  public:
    static void	_eval(top__Syms* __restrict vlSymsp);
    static void	_eval_initial(top__Syms* __restrict vlSymsp);
    static void	_eval_settle(top__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__1(top__Syms* __restrict vlSymsp);
} VL_ATTR_ALIGNED(64);

#endif  /*guard*/
